/*  combatd.c - combat arbitrator daemon

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

// MudOS v21.6 #pragma optimize's jump threading has bug! (line 200)
//#pragma optimize

#pragma save_binary

#include <ansi.h>
#include <combat.h>

//#define SHOW_DAMAGE
//#define SHOW_COMBAT_STAT

inherit F_CLEAN_UP;
inherit F_DBASE;

string *catch_hunt_msg = ({
    HIW "$NM$nHۨ~Aߨ襴F_ӡT\n" NOR,
    HIW "$N$njܡRuicASOATv\n" NOR,
    HIW "$NM$n@IAGܤNF_ӡT\n" NOR,
    HIW "$N@h$nAuv@nĤFLӡT\n" NOR,
    HIW "$NܹDRuTO]v\n" NOR,
    HIW "$NܹDRuǩRӡTv\n" NOR
});

string *dead_msg = ({
    "\n$NFC\n\n",
    "\n$NRXXfAAzFXU ... FC\n\n",
    "\n$N˪צbyALyXAAݬOFC\n\n",
    "\n$NDuFXnAyX@fAAK_FC\n\n",
    "\n$NwbaWALOaäF@|AHYhC\n\n",
});

void create()
{
    seteuid(getuid());
    set("name", "԰F");
    set("id", "combatd");
}

string damage_msg(int damage, string type)
{
    string str;

    if( !type ) type = "ˮ`";
#ifdef SHOW_DAMAGE
    return "Gy " + damage + " I" + type + "C\n";
#else
    if( damage == -1 ) switch(type) {
    case "":
        return "Guyva@nӥۡC\n";
    case "ζ":
        return "Guva@nX@DʤfC\n";
    case "":
        return "GuPva@nFihC\n";
    default:
        return "GR$nC\n";
    }

    if( damage == 0 ) return "GGSy㪺ˮ`C\n";
    if( damage > 100 ) damage = 100;

    switch( type ) {
    case "":
    case "ζ":
        if( damage < 5 ) return "GuOa}$p֦סC\n";
        else if( damage < 10 ) return "Gb$p$lX@DӪ岪C\n";
        else if( damage < 20 ) return "Guva@nX@DˤfT\n";
        else if( damage < 40 ) return "Guva@nX@DOOˤfT\n";
        else if( damage < 60 ) return "Guva@nX@DSS`ˤfAqo$NyAT\n";
        else return "Guť$n@nGzA$wwb$p$lX@D`ΨiȶˤfTT\n";
        break;
    case "":
        if( damage < 5 ) return "GuOa}$p֦סC\n";
        else if( damage < 10 ) return "Gb$p$lX@ӳФfC\n";
        else if( damage < 20 ) return "GuPva@nJF$n$lo\\T\n";
        else if( damage < 40 ) return "GuPva@ni$n$lA$pѦۥDahFXBT\n";
        else if( damage < 60 ) return "GuPva@nA$wwb$p$lX@ӦUk]KT\n";
        else return "Guť$n@nGzA$wwb$p$lӥXAAqoaTT\n";
        break;
    case "":
        if( damage < 2 ) return "Guԡva@nAiOGˮ`jC\n";
        else if( damage < 5 ) return "Gb$p$ly@BCC\n";
        else if( damage < 10 ) return "G@RA$n$lnɸ~F@ѰT\n";
        else if( damage < 20 ) return "G@RA$neF@nMYFpT\n";
        else if( damage < 40 ) return "Guyva@nA$nhFBT\n";
        else if( damage < 60 ) return "Go@Uuyva@no$nshFnXBAt@ILˡT\n";
        return "GaA$nuzva@nRX@fAT\n";
        break;
    default:
        if( damage < 2 ) str =  "GuOjjy@BL";
        else if( damage < 5 ) str = "GyL";
        else if( damage < 10 ) str = "Gy@B";
        else if( damage < 20 ) str = "Gy@BY";
        else if( damage < 30 ) str = "GyᬰY";
        else if( damage < 40 ) str = "Gy۷Y";
        else if( damage < 60 ) str = "GyQY";
        else if( damage < 80 ) str = "GyY";
        else str =  "GyD`iȪY";
        return str + type + "T\n";
    }
#endif
}

string eff_status_msg(int ratio)
{
    if( ratio==100 ) return HIG "( $Nݰ_ӨèSˡC )\n" NOR;
    if( ratio > 95 ) return HIG "( $NGFIˡALq~ݤjXӡC )\n" NOR;
    if( ratio > 90 ) return HIG "( $Nݰ_ӥiFIˡC )\n" NOR;
    if( ratio > 80 ) return HIY "( $NFXBˡALGäêơC )\n" NOR;
    if( ratio > 60 ) return HIY "( $NˤAݰ_ӪpäӦnC )\n" NOR;
    if( ratio > 40 ) return HIY "( $N𮧲ʭAʧ@}láAݨөҨ˵۹ꤣC )\n" NOR;
    if( ratio > 30 ) return HIY "( $Nwg˲ֲ֡AbjO伵ۤˤUhC )\n" NOR;
    if( ratio > 20 ) return HIR "( $NF۷ˡAuȷ|ͩRMIC )\n" NOR;
    if( ratio > 10 ) return HIR "( $N˭UwgH伵AݴNn˦baWC )\n" NOR;
    if( ratio > 5  ) return HIR "( $N˹LAwgaa@ARbiFC )\n" NOR;
    return HIR "( $N˹LAwgpAHɳi_C )\n" NOR;
}

string status_msg(int ratio)
{
    if( ratio==100 ) return HIG "( $Nݰ_ӹoص{ת@I]bGC )\n" NOR;
    if( ratio > 95 ) return HIG "( $NGǯhΡA]\\OĤpAALkTwC )\n" NOR;
    if( ratio > 90 ) return HIG "( $Nݰ_ӥi঳ǲ֤FAX۶}lCFUӡC )\n" NOR;
    if( ratio > 80 ) return HIY "( $Nʧ@G}lIFAOMC )\n" NOR;
    if( ratio > 60 ) return HIY "( $NݼNNAݰ_ӪpäӦnC )\n" NOR;
    if( ratio > 40 ) return HIY "( $NGQhΡAݨOӬ۷YC )\n" NOR;
    if( ratio > 30 ) return HIY "( $Nwg@Y}ҼˡAbjO伵ۤˤUhC )\n" NOR;
    if( ratio > 20 ) return HIR "( $Nݰ_ӤwgOqߤFC )\n" NOR;
    if( ratio > 10 ) return HIR "( $NnY̸BnnױצaíAݴNn˦baWC )\n" NOR;
    return HIR "( $NwgJbgAAHɳiL˷whC )\n" NOR;
}

varargs void report_status(object ob, int effective)
{
    if( !ob->query_stat_maximum("kee") ) return;
    if( effective ) 
        message_vision( eff_status_msg(
            (int)ob->query_stat_effective("kee") * 100 / (int)ob->query_stat_maximum("kee") ), ob);
    else
        message_vision( status_msg(
            (int)ob->query_stat("kee") * 100 / (int)ob->query_stat_maximum("kee") ) , ob);
}

// fight()
//
// This function serves as a lowest level routine for combat system and
// is usually called from a daemon of combat skill such as unarmed, sword
// etc.

varargs int
fight(object me, object victim, string skill, mapping action, object weapon)
{
    int ability, strength, damage, gin_cost, force_bonus;
    string msg, force_skill;

    // YbD԰, B԰賣SQarrest, ԰ -Dragoon
    // userp(me) check, mob]ǦbD԰ϥX -dragoon
    if( environment(me)->query("no_fight") ) {
	if( !victim->query("unprotect_mark") 
	&& !me->query("unprotect_mark") ) return 0;
    }

    // Y԰@b_u, ԰ -Dragoon
    if( ( userp(me) && !interactive(me) ) 
    || ( userp(victim) && !interactive(victim) ) ) return 0;

    me->set_combat_message(action["action"]);
    me->set_temp("last_action", action);

    /* OD
     */
    strength = me->query_strength("attack");

    /* O԰vT:
     *
     * ODW[: ޯ *  * (\Oʤ + ۦY)% * 4
     *           => ޯ 100,  1000, Q\O, Lۦ, |W[ 400Kg OD
     * ݭn: ҼW[OD / 500;
     * Ӻ: H(1  1 + ҼW[OD / 30000)
     */
    gin_cost = 1;
    if( force_skill = me->skill_mapped("force") )
    {
        int ratio, kee_required, kee;

        if( !(ratio = me->query("force_ratio")) ) ratio = 75;

        force_bonus = me->query_skill("force") * me->query_stat("kee") 
                * (ratio + action["force"]) / 25;
        kee_required = force_bonus / 500;

        if( userp(me) && kee_required > 0 ) {
            kee = me->query_stat("kee");
            if( kee < kee_required )
                force_bonus = force_bonus * kee / kee_required;
        }

        /* ϥΤ\AHC\Oʤ԰ɡA| gin_cost = 0 */
        gin_cost = random(2 + force_bonus/30000);
    }

    /* Rv: O + ޯ + ۦY */
    ability = me->query_ability("attack")
        + me->query_skill(skill)
        + action["attack"]
        ;

    /* YH̩ҨϥΪޯ]xAhRvtC */
    ability -= random( victim->query_skill(skill) );

    /* YHW@өۦmĪGAhRvvTC */
    ability -= victim->query_temp("last_action/defense");

    /* ̮Ӥֳ\OC */
    if( userp(me) ) {
        if( me->query_stat("gin") > gin_cost ) {
            me->consume_stat("gin", gin_cost);
            strength += force_bonus;
        } else {
            // ̺֩nDO, FCO, t
            // ~ݦ -Dragoon
            me->consume_stat("gin", gin_cost/2 + 1);
            ability /= 2;
            strength /= 2;
        }
    }
    else strength += force_bonus;

    if( ability < 1 ) ability = 1;

    /* nDHi樾mC */
    me->set_temp("defend_message", 0);
    if( !victim->is_busy()
    &&  victim->defend(ability, strength, weapon ? weapon : me) )
    {
        string defend_msg;

        /* m\ANmT[J԰TC */
        defend_msg = me->query_temp("defend_message");
        me->add_combat_message( "A" );
        me->add_combat_message( stringp(defend_msg) ? defend_msg
                : "OS" );
        damage = -1;
    }
    else
    {
        string absorb_msg;

        /* mѡAHlOD|C */
        me->set_temp("absorb_message", 0);
        strength -= (int)victim->absorb(ability, strength,
                weapon ? weapon : me);
        absorb_msg = me->query_temp("absorb_message");
        me->add_combat_message( "A" );
        me->add_combat_message( stringp(absorb_msg) ? absorb_msg
                : "OQ$n}");

        /* YODQlAhͶˮ`C */
        /* Ͷˮ`Ah覡ּƺ -Dragoon */
        if( strength > 0 ) {
            if( weapon ) {
                damage = weapon->inflict_damage(strength, victim);
                me->gain_score("weapon mastery", random(me->query_attr("int")/3));
            } else {
                damage = me->inflict_damage(strength, victim);
                me->gain_score("unarmed mastery", random(me->query_attr("int")/3));
            }
        }
        else damage = 0;
    }

    /* Nˮ`{תT[J԰TC */
    if( damage >= 0 ) {
#ifdef SHOW_DAMAGE
        me->add_combat_message("A" + damage_msg( damage, action["damage_type"] ));
#else
        int max, percent;

        max = victim->query_stat_effective("kee");
        if( max ) percent = damage * 100 / max;
        else percent = -1;      /* Dͪˮ`T */
        me->add_combat_message("A" + damage_msg( percent, action["damage_type"]));
#endif
    }
    else me->add_combat_message("C\n");

#ifdef SHOW_COMBAT_STAT
    message_vision(sprintf(HIY "%sG[ޥ %d, OD %.2fkg]\n" NOR,
        me->name(), ability, strength / 1000.0), me);
#endif

    /* eX԰TC */
    msg = me->get_combat_message();
    if( stringp(msg) )
    {
        string *limbs = victim->query("limbs");

        if( !arrayp(limbs) || !sizeof(limbs) ) {
            msg = replace_string(msg, "$l", "W");
        } else {
            msg = replace_string(msg, "$l", limbs[random(sizeof(limbs))]);
        }
        if( weapon ) msg = replace_string(msg, "$w", weapon->name());

        message_vision( msg, me, victim);
        if( damage > 0 ) report_status(victim);
    }

    /* Ǧ^Ds(ˮ`O)ܧ̥iog */
    if( living(victim) ) {
        /* Oͪ */
        return damage;
    } else {
        /* ODͪA̯Oݤp 80 ~|og */
        // ability > 80 ILY, PpUforce expoL
        // eoت], ϥstakewgFhm쨺@
        // -Dragoon 
        return random(500) > ability ? damage : 0;
    }
}

// auto_fight()
//
// This function is to start an automatically fight. Currently this is
// used in "aggressive", "vendetta", "hatred", "berserk" fight.

void auto_fight(object me, object obj, string type)
{
    // Don't let NPC autofight NPC.
    if( !userp(me) && !userp(obj) ) return;

    // This call_out gives victim a chance to slip trough the fierce guys.
    call_out( "start_" + type, 0, me, obj);
}

// add check net connection of player, testing work or not -Dragoon
void
start_hatred(object me, object obj)
{
    if( !me || !obj ) return;   // Are we still alive(not becoming a corpse)?

    if( !living(me)                             // Are we capable for a fight?
    ||  (userp(obj) && !interactive(obj))       // Is player net dead?
    ||  environment(me)!=environment(obj)       // Are we still in the same room?
    ||  environment(me)->query("no_fight")      // Are we in a peace room?
    )   return;

    // We found our hatred! Charge!
    message_vision( catch_hunt_msg[random(sizeof(catch_hunt_msg))], me, obj);
    me->kill_ob(obj);
    if( userp(obj) ) obj->fight_ob(me);
    else obj->kill_ob(me);
    me->attack(obj);
}

void
start_vendetta(object me, object obj)
{
    if( !me || !obj ) return;   // Are we still exist( not becoming a corpse )?

    if( me->is_fighting(obj)    // Are we busy fighting?
    ||  !living(me)             // Are we capable for a fight?
    ||  (userp(obj) && !interactive(obj))       // Is player net dead?
    ||  environment(me)!=environment(obj)       // Are we still in the same room?
    ||  environment(me)->query("no_fight")      // Are we in a peace room?
    )   return;

    // We found our vendetta opponent! Charge!
    message_vision( catch_hunt_msg[random(sizeof(catch_hunt_msg))], me, obj);
    me->kill_ob(obj);
    if( userp(obj) ) obj->fight_ob(me);
    else obj->kill_ob(me);
    me->attack(obj);
}

void start_aggressive(object me, object obj)
{
    int def;

    if( !me || !obj ) return;   // Are we still exist( not becoming a corpse )?

    if( me->is_fighting()       // Are we busy fighting?
    ||  !living(me)             // Are we capable for a fight?
    ||  (userp(obj) && !interactive(obj))       // Is player net dead?
    ||  environment(me)!=environment(obj)       // Are we still in the same room?
    ||  environment(me)->query("no_fight")      // Are we in a peace room?
    ||  obj->query("life_form") == "ghost"	// Only kill living -Dragoon
    ||  me->query_stat("kee") < obj->query_stat("kee")
    )   return;

    // let cor, cps, and command: agg work -dragoon
    def = (int)me->query_attr("cps");
    if( me->query_temp("ashura/aggressive") < 1 )
	def += (int)me->query_attr("cps");
    if( random(me->query_attr("cor")) < def ) return;

    /* ùڹJLaɡAuդۤvj */
//  n]ϤF??  -dragoon
//    if( userp(me) && userp(obj) 
//    && obj->query_ability("intimidate") > me->query_ability("intimidate") )
//        return;

    // We got a nice victim! Kill him/her/it!!!
    message_vision( catch_hunt_msg[random(sizeof(catch_hunt_msg))], me, obj);
    me->kill_ob(obj);
    if( userp(obj) ) obj->fight_ob(me);
    else obj->kill_ob(me);
    me->attack(obj);
}

// This function is to announce the special events of the combat.
// This should be moved to another daemon in the future.
void announce(object ob, string event)
{
    switch(event)
    {
    case "dead":
        message_vision( dead_msg[random(sizeof(dead_msg))], ob );
        break;
    case "unconcious":
        message_vision("\n$N}U@ӤíM^baW@ʤ]ʤFC\n\n", ob);
        break;
    case "revive":
        message_vision("\n$NCCC}MMFLӡC\n\n", ob);
        break;
    }
}

