/*  logind.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#pragma save_binary

#include <ansi.h>
#include <command.h>
#include <login.h>

inherit F_CLEAN_UP;
inherit F_DBASE;

int wiz_lock_level = WIZ_LOCK_LEVEL;

string *user_race = ({
    "blackteeth",
    "human",
    "yenhold",
    "woochan",
    "jiaojao",
    "rainnar", 
    "ashura",
    "headless",
    "yaksa",
    "malik"
});

string *banned_name = ({
    "A", "p", "", "L", "o", "e", "",
});

string *banned_rude_name = ({
    "F", "", "Q", "", "x", "Y", "", "", "",
});

string *banned_ip = ({
// Ȯɨ, Od, YOpۦPAҼ{ä[ban -dragoon
//	"163.19.7.%*s", 	// mutli, dragoon
//	"140.96.148.%*s",	// mutli, dragoon
});

string *banned_hostname = ({
	"%*s.Dorm2.nsysu.edu.tw",	// mutli, rude words, dragoon
});

#ifdef ENABLE_ANTISPAM
mapping spammer_player = ([]);
mapping spammer_ip = ([]);
string *penalty_attr = ({
    "str", "int", "dex", "con", "spi", "cps", "wis", "cor"
});
#endif	/* ENABLE_ANTISPAM */

private void get_id(string arg, object ob);
private void confirm_id(string yn, object ob);
private void get_email(string email, object ob);
object make_body(object ob);
private void init_new_body(object link, object user);
varargs void enter_world(object ob, object user, int silent);
varargs void reconnect(object ob, object user, int silent);
object find_body(string name);
int check_legal_id(string arg);
int check_legal_name(string arg);
private int list_user_race(object link);
private void increment_visitor_count();
private int check_ip(object link);

private void
create() 
{
    seteuid(getuid());
    set("channel_id", "suF");
}

private void
reset()
{
    object room, ob;

#if 0
    /* MŦb void ̪_uaC */
    room = find_object(VOID_OB);
    seteuid(getuid());
    if( objectp(room) )
	foreach(ob in all_inventory(room)) {
#ifdef	SAVE_USER
	    if( userp(ob) ) ob->save();
#endif
	    destruct(ob);
	}
#endif

    /* OuWϥΪ̤H */
    log_file("USRGRAPH", sprintf("[%s] %d users\n",
	ctime(time()), sizeof(users())));

#ifdef ENABLE_ANTISPAM
    spammer_player = ([]);
    spammer_ip = ([]);
#endif
}

void
logon(object ob)
{
    object *usr;
    int i, wiz_cnt, ppl_cnt, login_cnt;

#ifdef ENABLE_ANTISPAM
    if( spammer_ip[query_ip_number(ob)] >= 10 ) {
        write("qzsuDгyHӦhFMzDNQڵӤ@qɶC\n");
        destruct(ob);
        return;
    }
#endif

    seteuid(getuid());
    efun::write(read_file(WELCOME) + "");
    UPTIME_CMD->main();
    VISITOR_CMD->main();

    usr = users();
    wiz_cnt = 0;
    ppl_cnt = 0;
    login_cnt = 0;
    // invis wizard count in ppl in stead of wiz, by grain (03/25/1998)
    for(i=0; i<sizeof(usr); i++) {
        if( !environment(usr[i]) ) login_cnt++;
        else if( wizardp(usr[i]) ) {
            if( !usr[i]->link()->query("invis") ) wiz_cnt++;
        }
        else ppl_cnt++;
    }
    printf("ثe@ %d ŮvB%d 쪱abuWMH %d ϥΪ̹ճsuC\n\n",
        wiz_cnt, ppl_cnt, login_cnt );

    write("zϥΪ̥NG");
    input_to( "get_id", ob );
}

private void
get_id(string arg, object ob)
{
    object ppl;

    arg = lower_case(arg);
    if( !check_legal_id(arg)) {
	write("zϥΪ̥NG");
	input_to("get_id", ob);
	return;
    }

    /* ]wsuv */
    seteuid(arg);
    export_uid(ob);
    seteuid(getuid());
    ob->set("id", arg);

#ifdef MAX_USERS
    if( wizhood(arg)=="(player)" && sizeof(users()) >= MAX_USERS )
    {
	ppl = find_body(arg);
	// Only allow reconnect an interactive player when MAX_USERS exceeded.
	if( !ppl || !interactive(ppl) ) {
	    write("藍_M" + MUD_NAME + "ϥΪ̤wgӦhFMЫݷ|AӡC\n");
	    destruct(ob);
	    return;
	}
    }
#endif

#ifdef ENABLE_BAN_SITE
    // Rework by Annihilator (11/10/1999), support IP address and hostname
    if( wizhood(arg)=="(player)" )
    {
	string ip, pattern;

	ip = query_ip_number(ob);
	foreach(pattern in banned_ip)
	    if( ip==pattern || sscanf(ip, pattern) ) {
		write("藍_AzsumثeϥΪ̵nJC\n");
		destruct(ob);
		return;
	    }
	ip = query_ip_name(ob);
	foreach(pattern in banned_hostname)
	    if( ip==pattern || sscanf(ip, pattern) ) {
		write("藍_AzsumثeϥΪ̵nJC\n");
		destruct(ob);
		return;
	    }
    }
#endif	/* ENABLE_BAN_SITE */

#ifdef WIZ_LOCK_LEVEL
    if( (int)wiz_level(arg) < (int)wiz_lock_level ) {
        write("藍_M" + MUD_NAME + "ثeŮv " + WIZ_LOCK_LEVEL
            + " HWH~suC\n");
        destruct(ob);
        return;
    }
#endif

    if( arg=="guest" ) {
        // If guest, let them create the character.
        get_email( "guest@" + query_ip_name(ob), ob);
        return;
    }

    if( file_size(login_data(arg)) != -1 ) {
        if( ob->restore() ) {
            write("пJKXR");
            input_to("get_passwd", 1, ob);
            return;
        }
        write("藍_MzHxsץXF@ǰDMЧQ guest HqŮvBzC\n");
        destruct(ob);
        return;
    }

    write("ϥ " + (string)ob->query("id") + " oӦWrN|гy@ӷsHMzTw(y/n)S");
    input_to("confirm_id", ob);
}

private void
get_passwd(string pass, object ob)
{
    string my_pass;
    object user;

    write("\n");

    if( !check_ip(ob) ) {
	write("藍_AzsumTC\n");
	destruct(ob);
	return;
    }

    my_pass = ob->query("password");
    if( crypt(pass, my_pass) != my_pass ) {
        write("KX~I\n");
        destruct(ob);
        return;
    }

    user = find_body(ob->query("id"));
    if (user) {
	/* _uϥΪ̭ssu */
        if( !user->link() ) {
            reconnect(ob, user);
            return;
        }
        write("znNt@ӳsuۦPHXhMӥNܡS(y/n)");
        input_to("confirm_relogin", ob, user);
        return;
    }

    user = make_body(ob);
    if( ! user ) {
	/* pGSksyϥΪ̪A_su */
	destruct(ob);
	return;
    }

    if( user->restore() )
    {
	log_file( "USAGE", sprintf("[%s] %s login from %s\n",
	    ctime(time()), (string)user->query("id"), query_ip_name(ob) ) );

	if( wizhood(ob)=="(admin)") {
	    if( (query_ip_name(ob) != "localhost")
	    &&	(query_ip_number(ob) != "127.0.0.1") ) {
		write("wˬd....۰ʵnXC\n");
		destruct(user);
		destruct(ob);
		return;
	    }
	    write("wˬdqLC\n");
	}
	enter_world(ob, user);
	return;
    } else {
	if( file_size(user->query_save_file())==-1 ) {
	    write(@NOTICE
tΧ䤣zHơAi઺]]AzbгyHΤHbL@
_uAΪ̦]HϳWwzHƳQRFCpGzTwoӤHèS
WzoǱpAХ guest buWŮvdߡC

NOTICE
	    );
	    destruct(user);
	    write(HIY "znsгyoӤHܡH(y/n) " NOR);
	    input_to("confirm_reincarnate", ob);
	} else {
	    write(@NOTICE
tΥثeLkŪzHơAi઺]]AtΥbƤξzϥΪ
ơAеyԦAաC
NOTICE
	    );
	    destruct(user);
	    destruct(ob);
	}
    }
}

private void
confirm_reincarnate(string yn, object ob)
{
    if( yn=="" ) {
        write(HIY "znsгyoӤHܡH(y/n) " NOR);
        input_to("confirm_reincarnate", ob);
        return;
    }

    if( yn[0]!='y' && yn[0]!='Y' ) {
        write("naMwUAӡC\n");
        destruct(ob);
        return;
    }

    if( !list_user_race(ob) ) {
	/*  ~OALkL@pC */
#ifdef	SAVE_USER
	rm(ob->query_save_file());
#endif
        destruct(ob);
        return;
    }

    input_to("get_race", ob);
}

private void
confirm_relogin(string yn, object ob, object user)
{
    object old_link;

    if( yn=="" ) {
        write("znNt@ӳsuۦPHXhMӥNܡS(y/n)");
        input_to("confirm_relogin", ob, user);
        return;
    }       

    if( yn[0]!='y' && yn[0]!='Y' ) {
        write("naMwUAӡC\n");
        destruct(ob);
        return;
    } else {
        tell_object(user, "HqOB( " + query_ip_number(ob)
            + " )suNzұHC\n");
        log_file( "USAGE", sprintf("[%s] %12s replaced @ %s\n",
            ctime(time()),
            (string)user->query("id"),
            query_ip_name(ob),  ) );
    }

    // Kick out tho old player.
    old_link = user->link();
    if( old_link ) {
	seteuid(getuid());
	if( interactive(user) ) exec(old_link, user);
        destruct(old_link);
    }

    reconnect(ob, user);    
}

private void
confirm_id(string yn, object ob)
{
    if( yn=="" ) {
        write("ϥγoӦWrN|гy@ӷsHMzTw(y/n)S");
        input_to("confirm_id", ob);
        return;
    }       

    if( yn[0]!='y' && yn[0]!='Y' ) {
        write("naMЭsJz^WrR");
        input_to("get_id", ob);
        return;
    }

#ifdef ENABLE_ANTISPAM
    if( spammer_player[ob->query("id")] ) spammer_player[ob->query("id")]++;
    else spammer_player[ob->query("id")] = 1;
    if( spammer_ip[query_ip_number(ob)] ) spammer_ip[query_ip_number(ob)]++;
    else spammer_ip[query_ip_number(ob)] = 1;
#endif
    write("г]wzKXR");
    input_to("new_password", 1, ob);
}

private void
new_password(string pass, object ob)
{
    write("\n");
    if( strlen(pass)<5 ) {
        write("KXצܤ֭nӦrMЭ]zKXR");
        input_to("new_password", 1, ob);
        return;
    }
#ifdef	ENABLE_MD5_PASSWORD
    ob->set("password", crypt(pass, sprintf("$1$%d", random(99999999))));
#else
    ob->set("password", crypt(pass, 0) );
#endif
    write("ЦAJ@zKXMHT{zSOR");
    input_to("confirm_password", 1, ob);
}

private void
confirm_password(string pass, object ob)
{
    string old_pass;

    write("\n");
    old_pass = ob->query("password");
    if( crypt(pass, old_pass)!=old_pass ) {
        write("z⦸JKXä@ˡMЭs]w@KXR");
        input_to("new_password", 1, ob);
        return;
    }

    write(@TEXT
FקKzHDHsΡAES2 Nĥ email {Ҥ覡O@H
ҦvAҥHбzJ@ӥiѱ{ҥιqll󪺦a}C o
qlla}FŮvH~A|QLϥΪ̬ݨC
TEXT
    );
    write("zqlla}G");
    input_to("get_email",  ob);
}

private void
get_email(string email, object ob)
{
    int c, delim=0, err=0;

    if( strlen(email) > 64 ) {
	write("qlla}̦hiH 64 ӦrC\n");
	write("zqlla}G");
	input_to("get_email",  ob);
	return;
    }

    foreach(c in email) {
	if( c=='@' && !delim ) { delim = 1; continue; }
	if( strsrch("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_.", c) < 0 )
	    { err = 1; break; }
    }
    if( !delim || err ) {
	write("zqll榡~AпJTqlla}C\n");
	write("zqlla}G");
	input_to("get_email",  ob);
	return;
    }

    ob->set("email", email);

//  If ONE_GUEST is defined in /include/login.h, only permit one guest login.
#ifdef ONE_GUEST
    if ((string)ob->query("id") == "guest") {
        write("p, uWwg@ Guest F.\n");
        destruct(ob);
        return;            }
#endif /* ONE_GUEST */

    // Complete non-body-specific initialization of new user here.
    ob->set("karma", 20);
    list_user_race(ob);
    input_to("get_race", ob);
}

private void
get_race(string race, object ob)
{
    int kar;
    string choice;
    if( sscanf(race, "? %s", race) ) {
        write( read_file(HELP_DIR + "help/" + race) );
        // add by ueiren ... 
        // list_user_race(ob);
        input_to("get_race", ob);
        return;
    }
    if( member_array(race, user_race)==-1 ) {
        write("SoغرڡMбzsܡR");
        input_to("get_race", ob);
        return;
    }

    kar = (int)RACE_D(race)->query("karma");
    if( wizhood(ob)=="(player)" && (int)ob->query("karma") < kar ) {
        write("z~OMбzsܡR");
        input_to("get_race", ob);
        return;
    }
    ob->add("karma", -kar);

    write("zntk(m)Τk(f)S");
    input_to("get_gender", ob, race);
}

private void
get_gender(string gender, object ob, string race)
{
    object body;
    string body_file;

    if( gender=="" ) {
        write("zntk(m)Τk(f)S");
        // fix ʧO~y race  human bug  .... by ueiren
        // input_to("get_gender", ob, body);
        input_to("get_gender", ob, race);           
        return;
    }

    if( gender[0]=='m' || gender[0]=='M' )      gender = "male";
    else if( gender[0]=='f' || gender[0]=='F' )     gender = "female";
    else {
        write("藍_Mzuܨk(m)Τk(f)R");
        // fix ʧO~y race  human bug  .... by ueiren 
        // input_to("get_gender", ob, body);
        input_to("get_gender", ob, race);
        return;
    }

    if( !stringp(body_file = RACE_D(race)->query("default_body")) )
        body_file = USER_OB;
        ob->set("body", body_file);
        if( !(body = make_body(ob)) ) {
            destruct(ob);
            return;
        }

        body->set("gender", gender);
        body->set_race(race);
        init_new_body(ob, body);
        // Remember it so we can dest it if we go linkdead before finishing
        // chraracter creation.
        ob->set_temp("temp_body", body);

        write("zWrR");
        input_to("get_name", ob, body);
}

private void
get_name(string arg, object ob, object user)
{
    if( !check_legal_name(arg) ) {
        write("zWrR");
        input_to("get_name", ob, user);
        return;
    }

    ob->set("name", arg);
    user->set("name", arg);
    if( !ob->query("creation_time") ) {
        log_file( "USAGE", sprintf("[%s] %12s created  @ %s\n",
            ctime(time()),
            user->query("id"),
            query_ip_name(ob), ) );
            ob->set("creation_time", time());
            // default open chat and rumor channel -- by dragoon
            ob->set("channels", ({"chat","rumor"}));
    }
    enter_world(ob, user);
}

object
make_body(object link_ob)
{
    string err;
    object user;
    int n;

    seteuid(getuid());
    err = catch(user = new(USER_OB));
    if(err || !user) {
        write("{bi঳ŮvbקϥΪ̪󪺵{MеyԦAաC\n");
        return 0;
    }

    /* ]wϥΪ̪v */
    seteuid(getuid(link_ob));
    export_uid(user);
    seteuid(getuid());

    user->set("id", link_ob->query("id"));
    user->set_name( link_ob->query("name"), link_ob->query("id") );

    return user;
}

private int
check_ip(object link)
{                                                                               
    string okip, cur_ip, cur_ip_num, ip_part, num_part, be_checked;
    int len, ed;

    okip = link->query("okip");
    if( !arrayp(okip) || !sizeof(okip) ) return 1;

    cur_ip = query_ip_name(link);
    cur_ip_num = query_ip_number(link);
    foreach(string ip in explode(okip, ":") - ({ "" }))
    {
	if (sscanf(ip, "%s*", be_checked) && be_checked!="")
	{
	    len = strlen(be_checked);
	    ip_part = cur_ip[0..len-1];
	    num_part = cur_ip_num[0..len-1];
	}
	else if (sscanf(ip, "*%s", be_checked) && be_checked!="")       
	{
	    len = strlen(be_checked);
	    ed = strlen(cur_ip);
	    ip_part = cur_ip[ed-len..<1];
	    num_part = cur_ip_num[ed-len..<1];
	}
	else
	{
	    be_checked = ip;
	    ip_part = cur_ip;
	    num_part = cur_ip_num;
	}
       
	if (lower_case(be_checked) == lower_case(ip_part)
	|| lower_case(be_checked) == lower_case(num_part))
	{
	    write(HIW "ˬdqLC\n" NOR);
	    return 1;
	}
    }

    return 0;
}

private void
init_new_body(object link, object user)
{
#ifdef ENABLE_ANTISPAM
    int penalty;
    string a;
#endif

    user->set("birthday", time() );
    user->set_class("commoner");
    user->set_level(1);

#ifdef ENABLE_ANTISPAM
    penalty = spammer_player[user->query("id")] - 1;
    if( penalty < spammer_ip[query_ip_number(link)] )
        penalty = spammer_ip[query_ip_number(link)];
        while(penalty-- > 0) {
            a = penalty_attr[random(sizeof(penalty_attr))];
            if( user->query_attr(a) > 1 )
                user->set_attr(a, user->query_attr(a)-1);
        }
#endif

    CHAR_D->setup_char(user);
}

varargs void
enter_world(object ob, object user, int silent)
{
    object room;
    string startroom, err;

    /* NϥΪ̱qsu exec ϥΪ̪W */
    user->set_link(ob);
    ob->set_body(user);
    exec(user, ob);

    if( !silent ) write("ثevR" + wizhood(user) + "\n");
    user->setup();
    increment_visitor_count();

#ifdef SAVE_USER
    /* boxsAsгyHQsU */
    user->save();
#endif

    if( silent ) return;

    cat(MOTD);
    IDENT_D->query_userid((string)user->query("id"));

    /* HwkJϥΪ̵nJж */
    startroom = user->query("startroom");
    if( !startroom ) startroom = START_ROOM;
    err = catch(room = load_object(startroom));
    if( !room ) err = catch(room = load_object(VOID_OB));

    if( !room || !user->move(room) ) {
	write(@NOTICE
藍_AثetΥbפ@ǵnJaI{AеyԦAաC
NOTICE
	);
	destruct(ob);
	destruct(user);
	return;
    }

    /* ˬdϥΪ̬O_ŪH */
    if( ob->query("new_mail") ) {
	write( HIW "\nzHIШ毸Ӥ@ ...\n\n" NOR);
	ob->delete("new_mail");
    }
 
    // if detect mark: pker, set the time mark -dragoon
    if( user->query("pker") ) {
	user->set("last_pk_time", time());
	user->delete("pker");
    }

    /* ŧiϥΪ̵nJ */
    if( !wizardp(user) && !user->query("invis") ) {
	message("vision", user->query("name") + "suiJoӥ@ɡC\n",
		room, user);
	CHANNEL_D->do_channel( this_object(), "sys",
		sprintf("%s(%s)%ssuiJC",
		user->name(1),
		user->query("id"),
		query_ip_name(user))
	);
    }
}

varargs void
reconnect(object ob, object user, int silent)
{
    /* NϥΪ̱qsu exec ϥΪ̪W */
    user->set_link(ob);
    ob->set_body(user);
    exec(user, ob);

    user->reconnect();
    IDENT_D->query_userid((string)user->query("id"));   

    if( silent ) return;

    // if detect pking, reset time mark to now -dragoon
    if( time() - (int)user->query("last_pk_time") < 60 * 60 )
	user->set("last_pk_time", time());

    /* ŧiϥΪ̭ssu */
    if( !wizardp(user) && !user->query("invis") ) {
	message("vision", user->query("name") + "ssu^oӥ@ɡC\n",
		environment(user), user);
	CHANNEL_D->do_channel( this_object(), "sys",
		sprintf("%s(%s)%sssuiJC",
		user->name(1),
		user->query("id"),
		query_ip_name(user))
	);
    }
}

void
net_dead(object ob)
{
    CHANNEL_D->do_channel( this_object(), "sys",
        sprintf("%s(%s)_uFC", ob->name(1), ob->query("id")));
    ob->move("/obj/void");
}

int
check_legal_id(string id)
{
    int i;

    i = strlen(id);
    if( (strlen(id) < 3) || (strlen(id) > 12 ) ) {
        write("藍_Mz^WrO 3  12 ӭ^rC\n");
        return 0;
    }
    while(i--)
        if( id[i]<'a' || id[i]>'z' ) {
            write("藍_Mz^Wruέ^rC\n");
            return 0;
        }

    return 1;
}

int
check_legal_name(string name)
{
    int i;
    string bname;

    i = strlen(name);

    if( (strlen(name) < 2) || (strlen(name) > 12 ) ) {
        write("藍_AzWrO 1  6 ӤrC\n");
        return 0;
    }
    while(i--) {
        if( name[i]<=' ' ) {
            write("藍_MzWrαrC\n");
            return 0;
        }
        if( i%2==0 && !is_chinese(name[i..<0]) ) {
            write("藍_MбzΡuvWrC\n");
            return 0;
        }
        if( name[i..i+1]=="@" ) {
            write("藍_MФnΪťզrWrC\n");
            return 0;
        }
    }
    if( member_array(name, banned_name)!=-1 ) {
        write("藍_MoئWr|yLHxZC\n");
        return 0;
    }
    foreach(bname in banned_rude_name)
        if( strsrch( name, bname )>-1 ) {
            write("藍_, oئWl|ް_n~|C\n");
            return 0;
        }
    return 1;
}

object
find_body(string name)
{
    object ob, *body;

    if( objectp(ob = find_player(name)) ) return ob;
    foreach(ob in children(USER_OB))
        if( clonep(ob)
        &&  userp(ob)
        &&  ob->is_character()
        &&  getuid(ob) == name )
            return ob;

    return 0;
}

int
set_wizlock(int level)
{
    if( wiz_level(this_player(1)) <= level ) return 0;
    if( geteuid(previous_object()) != ROOT_UID ) return 0;

    wiz_lock_level = level;
    return 1;
}

static int
list_user_race(object link)
{
    string msg, race;
    int karma;

    karma = link->query("karma");
    msg = "";
    foreach(race in user_race) {
	if( RACE_D(race)->query("karma") > karma ) continue;
	msg += sprintf("%-25s %d I~O\n",
		to_chinese(race) + "(" + race + ")",
		RACE_D(race)->query("karma") );
    }

    if( msg=="" ) {
	write("AҳѪ~OwgSkL@FI\n");
	return 0;
    }

    msg = "z{b@ " + karma + " I~OAiHܥHUرڡG\n" + msg;
    msg += "z( '? <رڦW>' id\\)R";

    write(msg);
    return 1;
}

/*  reincarnate()
 *
 *  oӨƬOΨ@ player L@ΪChWu CHAR_D ~ݭn
 *  sγoӥ\AsγoӨƪ󥲶㦳 ROOT vC
 */

void
reincarnate(object ob)
{
    object link;
    int max_karma_gain, karma_gain;

    if( previous_object() && geteuid(previous_object()) != ROOT_UID )
	return;

    seteuid(getuid());

    /* pGi@H_uFAUsuɭԦA@ */
    link = ob->link();
    if( ! link ) {
#ifdef	SAVE_USER
        ob->save();
#endif
        destruct(ob);
        return;
    }

    /* Co~O MIN(WuѼ*2, @ɤH) */
    max_karma_gain = link->query("time_aged") / 43200;
    karma_gain = ob->query_level();
    if( karma_gain > max_karma_gain ) karma_gain = max_karma_gain;
    link->add("karma", karma_gain);
#ifdef	SAVE_USER
    link->save();
#endif

    /* NϥΪ exec suWARH */
    exec(link, ob);
#ifdef	SAVE_USER
    rm(ob->query_save_file());
#endif
    destruct(ob);

    /* pGҳѷ~Owg@رڡAŧi GAME OVER */
    if( !list_user_race(link) ) {
        write("бzsгy@ӤHAsAӧaC\n");
#ifdef	SAVE_USER
        rm(link->query_save_file());
#endif
        destruct(link);
        return;
    }

    input_to("get_race", link);
}

#define VISITOR_COUNTER_FILE	"/adm/etc/visitor.cnt"

private void
increment_visitor_count()
{
    int t, cnt;
    string s = read_file(VISITOR_COUNTER_FILE);

    if( !s ) 
        s = sprintf("%d 1", time());
    else {
        sscanf(s, "%d %d", t, cnt);
        if( ! t ) { t = time(); cnt = 0; }
        s = sprintf("%d %d", t, cnt+1);
    }
    write_file(VISITOR_COUNTER_FILE, s, 1);
}
