/*  object.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

varargs int
getoid(object ob)
{
    int id;

    if (!ob) ob = previous_object();
    sscanf(file_name(ob), "%*s#%d", id);
    return id;
}

// Get the owner of a file.  Used by log_error() in master.c.
string
file_owner(string file)
{
    string name, rest, dir;

    if (file[0] != '/') file = "/" + file;
    if (sscanf(file, "/u/%s/%s/%s", dir, name, rest) == 3) {
        return name;
    }
    return 0;
}

/*  creator_file()
 *
 *  oӨƬO ES2 wtΪ֤ߡAC@ӪQ load ɭԡAtη|
 *  NoӪɦWǵ simul_efun  creator_file() ơAåB
 *  oӨƪǦ^ȧ@@ uidCb ES2 wtΤA
 *  uid ܳoӪ󪺳̰v( iHg seteuid ӴέCۤv
 *  v )Aoӳ̰vO¥ѪɦWMwA]A]iHES2
 *  wtάOڰbɮŪgvިWC
 *
 *  ES2 ثe uid o覡аѦҵ{XѡC
 */
string
creator_file(string file)
{
    string *path, euid;

    path = explode(file, "/") - ({ "" });
    if( ! sizeof(path) )
	return 0;	/* oӱpӤ|o͡AuOwU@ */

    switch(path[0])
    {
	// ----------------------------------------------------------
	// b /adm M /cmds U֦̰v ROOT_UIDAiH
	// ơC
	// ----------------------------------------------------------
	case "adm":
	case "cmds":	return ROOT_UID;

	// -----------------------------------------------------------
	// }ϰ쪺v DOMAIN_UIDAiܨϥΪ̪ݩʡAgJ
	// ɮסC
	// -----------------------------------------------------------
	case "d":	return DOMAIN_UID;

	// -----------------------------------------------------------
	// b /u  /open UpGOѨϥΪ̸JAhoϥΪ̪
	// PvApGOѨϥΪ̸JAhoMJۦPv
	// C
	// -----------------------------------------------------------
	case "u":
	case "open":
	    if( this_player(1) ) euid = getuid(this_player(1));
	    if( !euid ) euid = geteuid(previous_object(1));
	    if( euid && euid != ROOT_UID ) return euid;
            return "NONAME";

	// ------------------------------------------------------------
	// b /obj ṴvѸJӪv(euid)MwAy
	// ܻѨ㦳 ROOT_UID vJ /obj AN㦳 ROOT
	// vAѨϥΪ̸JN㦳ϥΪ̪vC@㦳 ROOT v
	// pGnJ /obj Aq`| seteuid Av
	// AiJC
	// ------------------------------------------------------------
	case "obj":
	    if( previous_object(1) ) return geteuid(previous_object(1));
	    return "NONAME";

	// ------------------------------------------------------------
	// LؿU󳣵 MUDLIB_UID v
	// ------------------------------------------------------------
	case "daemon":
	default:
	    return MUDLIB_UID;
    }
}

void
destruct(object ob)
{
    string err;

    if( !ob ) return;

    err = catch(ob->remove());

    if( err )
	log_file("destruct", sprintf("[%s] %O: %s", ctime(time()), ob, err));

    if( userp(ob)
    &&	(geteuid(previous_object())!=ROOT_UID)
    &&	(geteuid(previous_object())!=geteuid(ob)) ) {
	log_file("destruct", sprintf("[%s] %O: Destructed by %s denied\n",
	    ctime(time()), ob, err));
	error("Destruction denied.\n");
    }

    efun::destruct(ob);
}
