/*  backstab.c - the backstab command

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <ansi.h>

inherit F_CLEAN_UP;

#define DELAY_COUNTDOWN         3

#define INITIAL_COUNTDOWN       DELAY_COUNTDOWN + 1
#define ENGAGE_COUNTDOWN        DELAY_COUNTDOWN + 2
#define DOIT_COUNTDOWN          DELAY_COUNTDOWN + 3

int do_backstab(object, object);
int halt_backstab(object me);

private void create() { seteuid(getuid()); }

int main(object me, string arg)
{       
    object victim;

    if( me->query_stat("fatigue")>=me->query_stat_maximum("fatigue") )
        return notify_fail(me->name() + "¤FoذN欰A@NoөROC\n");

    if( me->query("life_form") == "ghost" )
        return notify_fail("HFN@FʤF, ֥h䫰_a!!\n");

    if( me->is_busy() )
        return notify_fail("Х halt AbơC\n");

    if( me->is_fighting() )
        return notify_fail("Awgb԰FC\n");

    if( !arg
    ||  arg == "corpse"
    ||  !(victim = present(arg, environment(me)))
    ||  victim==me
    ||  !victim->is_character() )
        return notify_fail("Anŧ֡H\n");

    if( environment(me)->query("no_fight") ) {
        if( !victim->query("unprotect_mark") ) {
            tell_object(me, "o̤԰C\n");
            return 1;
        }
    }
    
    // add by dragoon
    if( userp(victim) && !interactive(victim) ) 
        return notify_fail("oH{bbuWC\n");

    if( victim->query("no_fight") ) return notify_fail("C\n");

//    if( !arg ) return notify_fail("Anŧ֡H\n");

    if( me->skill_mapped("backstab") )
    {
        mapping weapon = me->query_temp("weapon");
        string skill;

        if( !mapp(weapon) || !sizeof(weapon) ) skill = "unarmed";
        else {
            skill = "dagger";
            if( !objectp(weapon["dagger"]) )
                return notify_fail("AuHŤΤPZi氽ŧC\n");
        }
        if( ! me->skill_mapped(skill) )
            return notify_fail("A enable AޯC\n");
    }
    else {
        write("A enable u" + to_chinese("backstab") + "v~i氽ŧC\n");
        return 1;
    }

    // aiHQstakeӽmbackstab -Dragoon
    if( !living(victim) && !victim->query("TARGET_STAKE") ) {
        write("AݭnŧoӳåAWڡI\n");
        return 1;
    }

    if( victim->query("TARGET_STAKE")
    && me->query_skill("backstab") > 40 ) {
        write("HHuA߱oʲLŧtޥI\n");
        return 1;
    }

    me->set_temp("pending/hidden", 0);
    write("A}lnaq" + victim->name() + "ICCa ... C\n\n");

    me->set_temp("backstab_countdown", INITIAL_COUNTDOWN);
    me->start_busy( (: do_backstab, victim :), (: halt_backstab :) );

    return 1;
}

int do_backstab(object victim, object me)
{
    int countdown, ability, defend, bonus;

    if( !me ) return 0;

    /* ˬdnŧHO_٦b */
    if( !victim || environment(me) != environment(victim) ) {
        tell_object(me, "\n...  uiAӳåwgbo̤FC\n");
        return 0;
    }

    /* oŧ̪ŧ{ǭ˼ƭpɭ */
    countdown = me->query_temp("backstab_countdown");
    if( ! countdown ) countdown = 4;

    /* b԰AH */
    if( me->is_fighting() ) {
        tell_object(me, "\nicA٬OIeĤHaC\n");
        return 0;
    }

    switch(countdown)
    {
    case INITIAL_COUNTDOWN:
        /* Ĥ@q */
        ability = 3 * (me->query_attr("dex") + me->query_skill("backstab"));
        defend = victim->query_ability("awarness")
                 + random(victim->query_stat("gin"));

        if( living(victim) && defend > ability ) {
            write("AQo{FI\n");
            victim->catch_backstab(me);
            return 0;
        }

        /* ٨So{AiJU@q */
        tell_object(me, CYN "\nݰ_" + victim->name()
                + "٨SıA| ... C\n\n" NOR);
        me->set_temp("backstab_countdown", ENGAGE_COUNTDOWN);
        me->improve_skill("backstab", 1 + random(me->query_attr("int")));
        return 1;

    case ENGAGE_COUNTDOWN:
        /* ĤGq */
        ability = 2 * (me->query_attr("dex") + me->query_skill("backstab"));
        defend = victim->query_ability("awarness")
                 + random(victim->query_stat("gin"));

        if( living(victim) && defend > ability ) {
            message_vision(HIY "\n$No{$nb$PIQItI\n" NOR,
                        victim, me);
            me->kill_ob(victim);
            me->start_busy(3);
            write(HIR "\nV|IQo{FI\n\n" NOR "AQ"
                        + victim->name() + "Fӱ⤣ΡI\n\n");

            /* Qŧ̪ */
	    // CѪˮ`MRv, for thief's low hp -dragoon
            victim->kill_ob(me);
            victim->add_temp("apply/attack", 2 * victim->query_level() );
            victim->add_temp("apply/damage", victim->query_level() );
            victim->attack(me);
            victim->add_temp("apply/attack", -2 * victim->query_level() );
            victim->add_temp("apply/damage", -victim->query_level() );

            /* ŧ̪N */
            me->gain_score("mortal sin", 1);
            me->set_temp("backstab_countdown", DELAY_COUNTDOWN);
            return 1;
        }
        write(CYN "\nA\\aӨ" + victim->name() + "IAǳưʤF ...\n\n" NOR);
        me->improve_skill("backstab", 1 + random(me->query_attr("int")));
        me->gain_score("mortal sin", random(10)+1);
        me->set_temp("backstab_countdown", DOIT_COUNTDOWN);
        return 50;

    case DOIT_COUNTDOWN:
        message_vision(HIY "\n$Nq$nI@DӥXAܹDGuhaI"
                + victim->rank("rude") + "Iv\n\n" NOR, me, victim);
        tell_object(victim, "IAQ" + me->name() + "q᭱ŧFI\n");
        me->kill_ob(victim);

        /* ŧ\¤O */
        bonus = 10 + me->query_skill("backstab")
                + 2 * me->query_skill("killerhood");

        me->add_temp("apply/damage", bonus/2);
        me->add_temp("apply/attack", bonus);
        me->attack(victim);
        if( random(victim->query_ability("defense"))
                < me->query_skill("killerhood") ) {
            message_vision(HIY "$Nŧ$noA$p@ɤLӡAyS"
                        "AѹꤣȮaeiG@BC\n" NOR,
                        me, victim);
            /* ⥻Al[U */
            me->attack(victim);
            me->attack(victim);
        }
        me->add_temp("apply/damage", - bonus/2);
        me->add_temp("apply/attack", - bonus);

        victim->kill_ob(me);

        /* g */
        me->improve_skill("backstab", 1 + random(me->query_attr("int")*2) );
        if( me->query_learn("killerhood") )
            me->improve_skill("killerhood", 1 + random(me->query_attr("dex")) );
        me->gain_score("mortal sin", bonus);

        return 0;

    default:
        /* Yb𤤡A˼ƭp */
        if( countdown > 0 && countdown <= DELAY_COUNTDOWN ) {
            me->set_temp("backstab_countdown", --countdown);
            return countdown;
        }
        return 0;
    }
}

int halt_backstab(object me)
{
    int countdown = me->query_temp("backstab_countdown");

    if( countdown > DELAY_COUNTDOWN ) {
        write("AFŧYC\n");
        me->supplement_stat("fatigue", 5);
        return 1;
    }
    write("ӿFAA⦣}æaQ樭AOSšI\n");
    return 0;
}

int help()
{
    write(@TEXT
O榡Gbackstab <ؼ>

oӫOAĤHi氽ŧtAŧ\iHĤHyܤjˮ`AO
Ѥ]|AIX֥NC

ŧ\vDnAuŧtޭǡvoӧޯ঳AӶˮ`Oh@
Pu⥻vvTAŧɥuŤAΨϥΤPuLbC
TEXT
    );
        return 1;
}
