/*  berserk.c - berserk command

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <ansi.h>

inherit F_CLEAN_UP;

void do_berserk(object);

private void create() { seteuid(getuid()); }

int
main(object me, string arg)
{
    object ob;
    mapping weapon;
    string skill;

    weapon = me->query_temp("weapon");

    if( me->is_busy() )
	return notify_fail("Х halt AbơC\n");

    /* NPC ˬdoǭ */
    if( userp(me) )
    {
	if( me->query_stat("fatigue") >= me->query_stat_maximum("fatigue") )
	    return notify_fail("AӲ֤FA𮧤@|aC\n");

	if( !me->query_learn("berserk", 1) )
	    return notify_fail("A|oޯC\n");

	if( !me->is_fighting() )
	    return notify_fail("Anb԰~IigðkI\n");

	if( mapp(weapon) && sizeof(weapon) ) {
	    foreach(skill, ob in weapon)
		if( skill[0..8] != "twohanded" )
		    return notify_fail("AZ~ϥγoؾԳNC\n");
	}

	if( me->query_stat("gin") < me->query_stat_maximum("kee")/10 )
	    return notify_fail("AOFC\n");

	me->supplement_stat("fatigue", 3);
    }

//    message_vision(HIR "\n$N@nqAjۡGuIv\n\n" NOR,
//	me);
    do_berserk(me);

    return 1;
}

void
do_berserk(object me)
{
    object ob, *enemy;
    int skill, power, cost, max_attack, max_hit, penalty, exp, kee_cost;

    /* berserk Oݮ𪺱jצөwAӪOO */
    // [WMOMxѪĥ, þWխberserk}aO, F]
    // berserk + powerblow ثeLɤO~, wd}ޯ঳A
    // WjxHOŶ, p: leadership  -dragoon
    cost = (me->query_attr("str")+me->query_attr("cor")) / 3 +
	me->query_stat("kee") / 30;
    if( me->query_stat("gin") < cost ) {
	tell_object(me, "A뤣FC\n");
	return;
    }
    // [W]w, berserkbCԤWүϥΪW
    // קKsriHbfr@ۥopUK
    kee_cost = me->query_stat_maximum("kee") / 8;
    if( me->query_stat("kee") < kee_cost ) {
	tell_object(me, "A𤣰FC\n");
	return;
    }

    message_vision(HIR "\n$N@nqAjۡGuIv\n\n" NOR,
        me);

    /* j׸ҮӪAƩMޯ঳ */
    skill = me->query_skill("berserk");
    power = cost * 3500;		/* ̤j(ʦ) 700Kg */
    max_attack = skill / 20;		/*  4 - 9 */
    if( max_attack < 4 ) max_attack = 4;
    max_hit = skill / 45;		/* ̤j = 4 */
    if( max_hit < 1 ) max_hit = 1;

    me->add_temp("apply/attack", skill/4);
    me->add_temp("apply/strength", power);

    /* IҦĤHApG٦lOAAhX */
    enemy = me->query_enemy();
    while( max_hit-- && max_attack ) {
	foreach(ob in enemy) {
	    if( ! ob ) continue;	/* pGĤHwgFALL :P */
	    // YOĤHbP@өж, L
	    if( environment(ob) != environment(me) ) continue;
	    me->attack(ob);
	    // CX@g, HyabԤǲ berserk, 
	    // gȻPޥ
	    exp = 1 + me->query_skill("berserk")/3
		+ random(me->query_skill("berserk"))/3;
 	    // bޥ, xѰޯǲߦU
 	    if( skill < 80 ) exp += random(me->query_attr("cor"));
	    me->improve_skill("berserk", exp);
	    if( --max_attack < 1 ) break;
	}
    }

    me->add_temp("apply/attack", - skill/4);
    me->add_temp("apply/strength", - power);

    /* O */
    if( userp(me) )
    {
	me->damage_stat("gin", cost/6);
//	me->consume_stat("gin", cost);
	me->consume_stat("kee", kee_cost);
	
	// 򥻪ϥθg, Pʬ
	if( me->query_skill("berserk", 1) < 180 )
	    me->improve_skill("berserk", 1 + random(me->query_attr("int"))*2);
	me->gain_score("combat", 1 + random(max_hit));

	me->start_busy(2);
    }
    else me->start_busy(1);
}

int help()
{
    write(@TEXT
O榡Gberserk

@ؾAXbLêԳθsޤϥΪԳNAǥѼȮɩʪumAHg
ɫB몺ձhĤHC

oإkʼɳZAӥBOƹdAObZjĤHɩe
ġA]oؾԳN@LkiAHmC
TEXT
    );
    return 1;
}
