/*  go.c - character move command

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#pragma optimize
#pragma save_binary

inherit F_CLEAN_UP;

int do_go(object me, object dest, string dir);

mapping default_dirs = ([
    "north":		"_",
    "south":		"n",
    "east":		"F",
    "west":		"",
    "northup":		"_",
    "southup":		"n",
    "eastup":		"F",
    "westup":		"",
    "northdown":	"_",
    "southdown":	"n",
    "eastdown":		"F",
    "westdown":		"",
    "northeast":	"F_",
    "northwest":	"_",
    "southeast":	"Fn",
    "southwest":	"n",
    "up":		"W",
    "down":		"U",
    "out":		"~",
]);

void create()
{
    /* ] go Oi|JLAҥHݭn euid */
    seteuid(getuid());
}

int main(object me, string arg)
{
    mixed dest;
    object env, obj;

    if( !arg ) return notify_fail("AnӤVS\n");

    if( me->is_busy() ) {
	write("nʽЧA halt פAbơC\n");
	return 1;
    }

    if( me->over_encumbranced() ) {
	write("AtLMʼuoC\n");
	return 1;
    }

    env = environment(me);
    if( !env ) return notify_fail("A̤]hFC\n");

    if( arg=="escape" ) {
	mapping exits = env->query("exits");
	string *dirs;
	if( mapp(exits) ) {
	    dirs = keys(exits);
	    arg = dirs[random(sizeof(dirs))];
	}
	else {
	    write("AwgLikFI\n");
	    return 1;
	}
    }

    if( !(dest = env->query("exits/" + arg)) ) {
	write("oӤVSXC\n");
	return 1;
    }

    // Load destination room and check its existence.
    if( !objectp(obj = stringp(dest) ? load_object(dest) : dest)) {
	write("o@ӤVXfDMгqŮvBzC\n");
	return 1;
    }
    
    // Check for mudlib apply valid_leave()
    if( function_exists("valid_leave", env) && !env->valid_leave(me, arg) )
	return 0;

    return do_go( me, obj, arg );
}

int do_go(object me, object obj, string dir)
{
    string min, mout, dir_name;
    object old_env;

    if( !me || !obj ) return 0;

    if( undefinedp(dir_name = default_dirs[dir]) ) dir_name = dir;

    if( me->is_fighting() ) {
	object *enemy, ob;
	int intimidate, my_energy;

	mout = "" + dir_name + "ӰkFC\n";
	min = "^^a]FLӡMҼ˦ǯTVC\n";

	enemy = me->query_enemy() - ({ 0 });
	intimidate = me->query_ability("intimidate");
	my_energy = me->query_stat("gin");
	foreach(ob in enemy)
	{
	    if( userp(ob) || !living(ob) ) continue;
	    if( environment(ob) != environment(me) ) continue;
	    if( ! me->visible(ob) ) continue;
	    if( ob->query_ability("intimidate") > intimidate
	    &&	random(ob->query_stat("gin")) > my_energy ) {
		tell_object(me, "AQ" + ob->name() + "צFI\n");
		me->start_busy(1);
		return 0;
	    }
	}
    } else {
        mout = "" + dir_name + "}C\n";
        min = "FLӡC\n";
    }

    old_env = environment(me);
    message( "vision", me->name() + mout, old_env, me );
    if( me->move(obj) && environment(me)==obj ) {
        message( "vision", me->name() + min, obj, me );
        me->set_temp("pending", 0);
        all_inventory(old_env)->follow_me(me, dir);
        return 1;
    }

    return 0;
}

int help(object me)
{
    write(@HELP
O榡 : go <V>
 
AwVʡC
 
HELP
    );
    return 1;
}
