/*  kill.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <ansi.h>

inherit F_CLEAN_UP;

void do_kill(object, object);

int main(object me, string arg)
{
    object obj;
    string *killer, callname;

    if( me->query("life_form") == "ghost" )
	return notify_fail("HFN@FʤF, ֥h䫰_a!!\n");

    if( !arg ) return notify_fail("AQ֡S\n");

    if( !(obj = present(arg, environment(me)))
    ||	!obj->is_character()
    ||	obj->is_corpse() )
	return notify_fail("ǫSoӤHC\n");

    // add by dragoon
    if( wizardp(obj) ) return notify_fail("!!\n");

    if( environment(me)->query("no_fight") ) {
	if( !obj->query("unprotect_mark") ) {
	    tell_object(me, "o̤԰C\n");
	    return 1;
	}
    }

    // add by dragoon
    if( userp(obj) && !interactive(obj) ) 
        return notify_fail("oH{bbuWC\n");

    if( obj->query("no_fight") ) return notify_fail("C\n");

    if( me->is_busy() ) return notify_fail("AQĤHo⦣} ...\n");

    if(obj==me) return notify_fail("AQܡS\n");

    me->set_temp("pending/hidden", 0);      // be visible
        
    if( ! me->is_fighting(obj)
    ||	! me->is_killing(obj) ) {
	switch( random(3) )
	{
	case 0:
	    message_vision("\n$N$nܹDRu" + obj->rank("rude")
		+ "T餣OANOڬTv\n\n", me, obj);
	    break;
	case 1:
	    message_vision("\n$N$nܹDRu" + obj->rank("rude")
		+ "AǩRӡIv\n\n", me, obj);
	    break;
	case 2:
	    message_vision("\n$N$nܹDRu" + obj->rank("rude")
		+ "A~ѴNOAҤIv\n\n", me, obj);
	    break;
	}
    }

    do_kill(me, obj);

    return 1;
}

void do_kill(object me, object obj)
{
    me->kill_ob(obj);

    if( obj->is_fighting(me) && obj->is_killing(me) ) return;

    if( userp(obj) )
    {
	/* 缾a kill O */
	obj->fight_ob(me);
	tell_object(obj, HIR "pGAnM" + me->name() 
	    + "ʩR۷iAЧA]oӤHU@ kill OC\n" NOR);
    }
    else {
	/*  NPC  kill O */
	if( function_exists("accept_kill", obj)
	&&  ! obj->is_killing(me)
	&&  obj->accept_kill(me) ) {
	    return; }

	if( ! obj->is_killing(me) ) obj->kill_ob(me);
	else if( ! obj->is_fighting(me) ) obj->fight_ob(me);
    }
}

int help(object me)
{
  write(@HELP
O榡 : kill <H>
 
oӫOADʶ}l@ӤHMåB|ձMkill M fight ̤j
PbN|uMjaM]NOM|uˡCѩ kill uݳ
@[@NiHߡM]AHϥ kill O|}l԰Mq`pG
O NPC ܡML̤]|P˹Aϥ killC

HAϥ kill Oɷ|X{⪺rĵiAM@ӪaӨMpG
AS@WĤHϥιL kill OMN|Nu˩α( ϥΪkN
ŧ~)C

LO: fight

 fight  kill ϤЬ 'help combat'.
HELP
    );
    return 1;
}
 
