/*  reply.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <ansi.h>
#include <net/dns.h>

#define MIN_REPLY_INTERVAL       3
#define MAX_REPLY_MESSAGE        1024

inherit F_CLEAN_UP;

int help(object me);

void create() { seteuid(getuid()); }

int main(object me, string arg)
{
    string target, mud, uid, *ignore;
    object obj;
    int idle_time, tmp;

    if( !arg || arg=="" )
	return notify_fail("An^S\n");

    if( !stringp(target = me->query_temp("reply")) )
	return notify_fail("~SHMALܡC\n");

    if( time() - (int)me->query_temp("last_reply_time") < MIN_REPLY_INTERVAL )
        return notify_fail("A𮧤@U~AרϥγoӫOC\n");

    me->set_temp("last_reply_time", time());

    if( strlen(arg) > MAX_REPLY_MESSAGE )
        return notify_fail("ATӪFAЪܵuC\n");

    if( sscanf(target, "%s@%s", target, mud)==2 ) {
	GTELL->send_gtell(lower_case(mud), lower_case(target), me, arg);
	write("TweXMinyԤ~o^C\n");
	return 1;
    }

    if( (!obj = find_player(target)) || (!interactive(obj)) )
	return notify_fail("~MAܪH{bLkťAMΪ̤wg}CFC\n");

    uid = getuid(me);
    ignore = obj->query("ignore");

    // add by dragoon to let tell work in sneak
    if( me->query_temp("pending/hidden") ) {
        tmp = me->query_temp("pending/hidden");
        me->delete_temp("pending/hidden");
    }

        if (pointerp(ignore) && member_array(uid, ignore) != -1  )
         return notify_fail(sprintf("%sQťA^C\n",obj->name(1)));
        if( obj->query_temp("netdead") )
          return notify_fail(sprintf(HIG"%s_u...\n"NOR,obj->name(1)));
        write("A^" + obj->name(1) + "(" + obj->query("id") + ")R"
                + HIG + arg + "\n" NOR);

    if ((idle_time = query_idle(obj)/60) > 2
    || in_input(obj)
    || in_edit(obj) ) {
                write(GRN+obj->name(1)+
                (idle_time>2 ? "wgob "+idle_time+" F" : "")+
                (in_input(obj) ? " <Jr> " : "")+
                (in_edit(obj) ? " <sɮפ> " : "")+
                ", iण|W^A...\n"+NOR);
    }

        tell_object(obj, sprintf("%s(%s)^AR" + HIG + "%s\n"NOR,
                me->name(1), me->query("id"), arg ));

    // reset hidden if it exist before use tell, -Dragoon
    if( tmp > 0 ) {
        me->set_temp("pending/hidden", tmp); }

        obj->set_temp("reply", me->query("id"));
        return 1;
}

int help(object me)
{
        write(@HELP
O榡Rreply <T>

AiHγoӫOM~ tell  reply PAܪϥΪ̻ܡCYobT
HW, γBJrA, νsɮתA, htη|ܩAC

see also : tell
HELP
        );
        return 1;
}
