/*  estimate.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

inherit F_CLEAN_UP;

int main(object me, string arg)
{
    object ob = me;
    int my_ability, my_defense, my_strength;
    int hir_ability, hir_defense, hir_strength;
    int cmp_ability, cmp_defense, cmp_strength;
    mapping weapon;
    string msg;

    if( arg ) {
	ob = present(arg, environment(me));
	if( !ob || !ob->is_character() || !ob->visible(me) )
	    return notify_fail("ǫS " + arg + " oӤHC\n");
    }

    // Calculate my attack ability

    my_ability = me->query_ability("attack");
    if( mapp(weapon = me->query_temp("weapon")) && sizeof(weapon) ) {
	int v, best = 0;
	string sk;
	object foo;

	foreach(sk, foo in weapon)
	    if( (v=me->query_skill(sk)) > best ) best = v;
	my_ability += best;
    }
    else my_ability += me->query_skill("unarmed");
    if( ! my_ability ) my_ability = 1;

    // Calculate my defense ability

    my_defense = me->query_ability("defense");
    if( me->skill_mapped("dodge") ) my_defense += me->query_skill("dodge");
    if( ! my_defense ) my_defense = 1;

    // Calculate my attack strength

    my_strength = me->query_strength("attack");
    if( me->skill_mapped("force") != "force" )
	my_strength += me->query_skill("force") * me->query_stat("kee") * 4;
    if( ! my_strength ) my_strength = 1;

    if( ob==me ) {
	printf("AۤvbZ\\ۼƤW %d {סC\n", my_ability);
	printf("um譱Ӧ %d ǡC\n", my_defense);
	printf("O@ܯ঳ %.2f 祪kODC\n", my_strength / 1000.0);
	return 1;
    }

    // Calculate target attack ability

    hir_ability = ob->query_ability("attack");
    if( mapp(weapon = ob->query_temp("weapon")) && sizeof(weapon) ) {
	int v, best = 0;
	string sk;
	object foo;

	foreach(sk, foo in weapon)
	    if( (v=ob->query_skill(sk)) > best ) best = v;
	hir_ability += best;
    }
    else hir_ability += ob->query_skill("unarmed");

    // Calculate my defense ability

    hir_defense = ob->query_ability("defense");
    if( ob->skill_mapped("dodge") ) hir_defense += ob->query_skill("dodge");

    // Calculate target attack strength

    hir_strength = ob->query_strength("attack");
    if( ob->skill_mapped("force") != "force" )
        hir_strength += ob->query_skill("force") * ob->query_stat("kee") * 4;

    // Give remarks.

    if( my_ability < 1 ) my_ability = 1;
    if( my_strength < 1 ) my_strength = 1;
    if( my_defense < 1 ) my_defense = 1;

    cmp_ability  = (my_ability - hir_ability) * 100 / my_ability;
    cmp_strength = (my_strength - hir_strength) * 100 / my_strength;
    cmp_defense  = (my_defense - hir_defense) * 100 / my_defense;

    msg = "A" + ob->name() + "Z\\bۼƤW";

    if( cmp_ability < -150 )
        msg += "өAA";
    else if( cmp_ability < -80 )
        msg += "XAƦhA";
    else if( cmp_ability < -40 )
        msg += "XA@IA";
    else if( cmp_ability < -10 )
        msg += "AӤ@wA";
    else if( cmp_ability < 10 )
        msg += "PAubB򤧶A";
    else if( cmp_ability < 40 )
        msg += "A@wA";
    else if( cmp_ability < 80 )
        msg += "MAۤᦳpA";
    else if( cmp_ability < 150 )
        msg += "MAۤtۦѤj@IA";
    else
        msg += "AӨ@c¯١A";

    msg += "bum譱";

    if( cmp_defense < -150 )
        msg += "өAA";
    else if( cmp_defense < -80 )
        msg += "XAƦhA";
    else if( cmp_defense < -40 )
        msg += "XA@IA";
    else if( cmp_defense < -10 )
        msg += "AӤ@wA";
    else if( cmp_defense < 10 )
        msg += "PAubB򤧶A";
    else if( cmp_defense < 40 )
        msg += "A@wA";
    else if( cmp_defense < 80 )
        msg += "MAۤᦳpA";
    else if( cmp_defense < 150 )
        msg += "MAۤtۦѤj@IA";
    else
        msg += "AӨ@c¯١A";

    if( cmp_defense * cmp_strength > 0 )
        msg += "ӥBbODW]";
    else
        msg += "ObODWo";

    if( cmp_strength < -150 )
        msg += "өAC\n";
    else if( cmp_strength < -80 )
        msg += "jLAƦhC\n";
    else if( cmp_strength < -40 )
        msg += "jLA@jIC\n";
    else if( cmp_strength < -10 )
        msg += "AӤ@wC\n";
    else if( cmp_strength < 10 )
        msg += "PAbB򤧶C\n";
    else if( cmp_strength < 40 )
        msg += "A@wC\n";
    else if( cmp_strength < 80 )
        msg += "ᤣpAC\n";
    else if( cmp_strength < 150 )
        msg += "tۧAѤj@IC\n";
    else
        msg += "AӨȤ@SC\n";

    write(msg);
    return 1;
}

int help()
{
    write(@TEXT
O榡Gestimate [<H>]

oӫOAj@ӹ⪺OApG[HAhOۤvZC
TEXT
    );
    return 1;
}
