/*  help.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include "/doc/help.h"

inherit F_CLEAN_UP;

static string *default_search = DEFAULT_SEARCH_PATHS;

private void create() { seteuid(getuid()); }

int main(object me, string arg)
{
    string file, *search;

    if( !arg ) {
        cat(HELP_DIR + "help/topics");
        return 1;
    }

    arg = replace_string(arg, " ", "_");

    // Else, try if a command name is specified.
    seteuid(getuid());
    if( stringp(file = me->find_command(arg)) ) {
        notify_fail("oӫOsbMOèSԲӪC\n");
        return file->help(me);
    }

    // Support efun/lfun help with same name as other topics such as
    // ed() and ed command.
    sscanf(arg, "%s()", arg);

    search = DEFAULT_SEARCH_PATHS;
    if( wizardp(me) )
        search += WIZARD_SEARCH_PATHS;
        
    foreach(string path in search)
    {
	if( file_size(path + arg) < 0 ) continue;
	if( wizardp(me) )
	    write("G" + path + arg
		+ "\n---------------------------------------------------------------------\n");
	me->start_more( read_file(path + arg) ); 
	return 1;
    }

    return notify_fail("SwoDDC\n");
}

int help(object me)
{
    write(@HELP
O榡Rhelp <DD>              ҦpR> help all
          help <ƦW>()        ҦpR> help call_out()

oӫOѧAwY@DDԲӻMYOwDDMhѧADD
MҦDDPƦW٬Ҭ^C
HELP
    );
    if( wizardp(me) )
        write(@HELP
O|jMDDO_ command, ( YIs̬Ův, h۷jM /doc/help.h
 WIZARD_SEARCH_PATHS ), AjM DEFAULT_SEARCH_PATHSC 
YPɦWBoǷjMm, hj|̱NQjM, Yuݨ
ejM doc, sssɽЯdNC
HELP
        );
    return 1;
}
