/*  praise.c - praise command to give user reputation

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <ansi.h>

inherit F_CLEAN_UP;

int main(object me, string arg)
{
    object ob;
    int level = me->query_level();
    string pro = me->query_class();

    seteuid(getuid());

    if( wizardp(me) ) return notify_fail("ŮvgOHC\n");

    // This prevent abuse of praise from new characters.
    if( level < 2 ) return notify_fail("AɨĤGŤAg~ĪGC\n");

    if( me->query("praise_done") )
        return notify_fail("A[e~gLOHAɯŤ~AgLHC\n");

    if( !arg || arg=="" )
        return notify_fail("Ang֡H\n");

    ob = find_player(arg);
    if( !ob ) return notify_fail("oӤHbuWC\n");
    if( wizardp(ob) )
        return notify_fail( ob->name() + "§AnNALЧAgAY઺aC\n");
    if( ob==me )
        return notify_fail("oӫOOΨӦ۸تAAu౵OHgC\n");

    log_file("praise", sprintf("[%s] %s praised %s at level %d.\n",
        ctime(time()), getuid(me), getuid(ob), level) );
    
    if( pro=="commoner")
        ob->gain_score("reputation", level-1);
    else
        ob->gain_score("reputation", (level-1) * (level-1) );

    me->gain_score("reputation", 1);
    if( pro!="commoner" && ob->query_class()==pro )
        CLASS_D(pro)->brother_praise(me, ob);
    me->set("praise_done", 1);

    shout( sprintf(YEL "%s%sgoF\\hH{PAôF%snI\n" NOR,
            me->name(), ob->name(), ob->name() ));
    write("Ok.\n");

    return 1;
}

int help()
{
    write(@TEXT
O榡Gpraise <a>

oӫOAgYAY઺aAô誺nAAɨĤGŤAC
ɯťiHXAg@AӱOHgèS󭭨ApGgA
aMA㦳ۦP¾~An洣ɪĪGinAΪ̤@ּW[@ǱM~nCY
OݥAhѩ󥻨bZLnAn椧ɮĪGtC
TEXT
    );
    return 1;
}
