// alchemist.c

#include <npc.h>

inherit F_VILLAGER;

void create()
{
	set_name("L", ({ "chen weisha", "weisha", "chen" }));
	set("nickname", "s~h");
	set_attr("dex", 18);
	set_attr("int", 24);
	set_attr("wis", 25);
	set_attr("spi", 22);
	set_attr("cps", 19);
	set_attr("con", 20);
	set_race("human");
	set_level(30);
	set_class("alchemist");
	set_skill("unarmed", 60);
	set_skill("sword", 60);
	set_skill("parry", 80);
	set_skill("dodge", 70);
	set_skill("force", 70);
	set_skill("kee anatomy", 100);
	set_skill("dragon force", 60);
	set_skill("alchemy-medication", 140);
	set_skill("alchemy-wealth", 40);
	set_skill("alchemy-magic", 80);
	set_skill("alchemy-immortality", 30);
	map_skill("force", "dragon force");

	advance_stat("gin", 180);
	advance_stat("kee", 180);
	advance_stat("sen", 180);

	set("age", 55);
	set("long",
		"LOӵۦWhMg`өѨP쳱ĤδMV\n"
		"é_qMLMF~O¤PMoX쥻nϤs\n"
		"ġMO]svhҥHȮɦb~aLټƤC\n"
		"LWסMLOLǥ̰ͭeLٸMNOL۷\n"
		"LMwꤣMYO~WlFiͤNM\n"
		"uȦXeNWϤsаshFC\n");
	setup();
	carry_object(__DIR__"obj/silversword")->wield();
	carry_object("/obj/area/obj/cloth")->wear();
}

void set_flag(object me)
{
	if( me && present(me, environment()) ) {
		if( me->query_class() != "commoner"
		||	me->query("title") )
			return;
		me->set_temp("pending/alchemist", 1);
	}
	else
		do_chat("LDRK ... HFMڳoY٦bۨۻy ...C\n");
}

int accept_apprentice(object me)
{
	if( is_chatting() ) return 0;
	if( me->query_temp("pending/alchemist") ) return 1;
	if( me->query("title") ) {
		do_chat("LD: ~H, ŦhhN, Oo|BAC\n");
		return 0;
	}
	do_chat(({
		"LDRڬvS ... ڥiOZLrC\n",
		"L۫Υ~XF|MDRڥuOӳwҤġBꤣYC\n",
		"LMF_ӡMDRuҤġBꤣv... ...C\n",
		"LDRڬݧAo~HٶMpGAȰǿNĪʬ ...\n",
		"LDRѤҪ{UdHMKhA@Ӥ]C\n",
		(: set_flag, me :)
	}));
	return 0;
}

int init_apprentice(object me)
{
	// add by dragoon
	if( me->query_class() != "commoner" ) {
		do_chat(({
			"LDRAJwJOMZlOAߧڤN?\n",
			"LMDRha.....C\n"
		}));
		return 1;
	}
	if( ::init_apprentice(me) ) {
                seteuid(getuid());
		me->set_class("alchemist");
		me->set("title", "sϤ̤l");
		do_chat(({
			"LIFIYMDRAMJڪUMOoNĤQ~C\n",
			"LDRQ~MpGvݧAٳyNMo~ǧANC\n",
			"L\\F\\MDRnFMAUhaC\n"
		}));
	}
}

int acquire_skill(object ob, string skill)
{
	if( is_chatting() )
		return notify_fail("A̦nLѤHaܻAL ...C\n");
	if( !ob->is_apprentice_of(this_object()) ) return 0;

	switch(skill) {
	case "alchemy-medication":
		if( !ob->query_learn(skill)
		&&	ob->query_score("alchemy") >= 1000 ) {
			say("LIFIYADGvoNǧAAťnFC\n");
			message_vision("$NNsϤDANjnǱµ$nC\n", this_object(), ob);
			ob->improve_skill(skill, random(ob->query_attr("wis")) + 1);
		}
		break;
	case "alchemy-wealth":
	case "alchemy-magic":
	case "alchemy-immortality":
	default:
		return 0;
	}

	do_chat(({
		"LDGZڤhHALw٥@ϤHvC\n",
		"LDGDJAO᪺׽m~}l ...\n",
		"LDGAnOi_JFyAX~XܡC\n",
		"LDGƱAn۬C\n",
	}));

	return 1;
}
