// child.c

#include <npc.h>

inherit F_VILLAGER;

void timeto_eat();

void create()
{
	set_name("_", ({ "arbao", "__ID_ARBAO__" }) );
	set_attr("spi", 18);
	set_attr("int", 19);
	set_attr("dex", 19);
	set_attr("con", 17);
	set_race("human");
	set_class("thief");
	set_level(10);

	set_skill("stealing", 40);
	set_skill("dodge", 35);
	set_skill("lightswift", 45);
	set_skill("dagger", 40);
	set_skill("sword", 30);
	
	map_skill("dodge", "lightswift");

	set("age", 16);
	set("gender", "female");
	set("long",
		"oӤQBphQNOu_vFMoWM۲ʥ\n"
		"AMoQOӬHFlM@LLjLLa\n"
		"ۡM٤ɨnۧAݡMϧATıoǵo~C\n");

	// set arbao to consume food -dragoon
	set("schedule", ([
	    700: (: timeto_eat :),
	    1200: (: timeto_eat :),
	    1900: (: timeto_eat :),
	]));

	setup();
	carry_money("coin", 30);
	carry_object(__DIR__"obj/blue_cloth")->wear();
	carry_object("/obj/area/obj/dagger")->wield();
}

int hungry = 1;

void timeto_eat()
{
	this_object()->consume_stat("food", 
	    this_object()->query_stat("food")+1);
	return;
}

void init()
{
	::init();
	if( is_fighting() || is_chatting() ) return;
	
	if( this_player()->query_temp("try/fon")==10 ){
		do_chat("_}ߪVAnn, ݹD: hjF ? Lnn?\n");
		//this_player()->set_temp("try/fon",13);
	}

	// if trying fon, wont join thief
	if( this_player()->query_temp("try/fon") )
		return;

	if( hungry )
		do_chat((: command, "say  ... ڨ{lnjMSYS" :));
	else if( this_player()->query_class() == "thief" ) {
		do_chat(({
			"_ۧAAMDGxHAOWڪFY ...\n",
			"_LDGSbo̹JAAuC\n"
		}));
	}
	else
		do_chat((: command, "say N ... OCCDڦbo ..." :));
}

private void give_comb(object player)
{
	object comb;

	if( !player || environment(player)!=environment() ) {
		command("say x ... HOS");
		return;
	}
	comb = new(__DIR__"obj/comb");
	comb->move(this_object());
	command("give comb to " + player->query("id"));
}

private void exchange(string food_name, object player)
{
	set_stat_current("food", 0);
	command("eat " + food_name);
	if( !player || environment(player) != environment() ) return;

	command("say F ... ӥզYAFMoӰeAaT");
}

private void do_follow(object me,object ob)
{
	if( !ob->move(me) )	ob->move(environment(me));
	message_vision("_@󪫫~F$N.\n",me);
	command("follow "+me->query("id"));
	me->set_temp("try/fon",43);
}

int accept_object(object me, object ob)
{
	if(me->query_temp("try/fon")!=40){
		if( !hungry || !inherits(F_FOOD, ob) ) {
			do_chat((: command, "say ڳoӷFS" :));
			return 0;
		}

		hungry = 0;
		command("smile");
		command("say  .. ӦnFTu§AT ...");
		do_chat(({ (: exchange, ob->query("id"), me :), (: give_comb, me :) }));
		return 1;
	}
	if(ob->id("__ID_CHALLIE__")){
		do_chat(({
			"_JӬݤFݯ}.\n",
			"_D: o......ڴNDhaL.....ݷ..\n",
			"_ˤߪF_.\n",
			"_Fn@}l, ~SAD: §A, ڭ̳oNha.\n",
			(: do_follow,me,ob :),
		}));
		hungry=0;		// stop talking about another quest by init
		return 1;
	}
}

void relay_say(object ob,string msg)
{
	int tmp = ob->query_temp("try/fon");

	// communicate with gammer
	if( !userp(ob) ){
		if( ob->id("__ID_GAMMER__") ){
			if( strsrch(msg,"|AhLM")>= 0 ) {
				do_chat(
(:command("say u! ӦnF!"):));
				return;
			}
			if( strsrch(msg,"wWhE")>= 0 ) {
				do_chat(({
"_yF@U.\n",
(:command("say O."):),
				}));
				return;
			}
			if( strsrch(msg,"AݷݳF")>= 0 ) {
				all_inventory(environment())->set_fon_temp(this_player());
				call_out((:do_chat(
"_D: ߱n, ڭnho, ЧAڥhiDhjoӦn, 
h§AF.\n"):),4);
				call_out((:do_chat(
"_, ]榣l۽MѤӱCh.\n"):),5);
				call_out((:destruct(this_object()):),8);
			}
		}
		return;
	}
	// communicate with user
	switch(tmp){
		case 0:
		case 1:
			if( (strsrch(msg, "hj~|^") >= 0) ) {
				do_chat(({
"_y@MDGA .. AOʤshEhjܡS\n",
"_DGoiVFMLoɭԦ^ӡMCCwnFL ... OS\n",
"_D: o"+ob->rank("respectful")+"i_pkl@Ӧ?\n",
				}));
				ob->set_temp("try/fon",3);
			}
			break;
		case 3:
			if( strsrch(msg,"i")>=0 || strsrch(msg,"n")>=0 ){
				do_chat(({
"_D: pGAJWhj, ЧAiDLȮ٬OOӳF, M, nOL
MCC_FĬ,ڷ|ܬ.٦.....\n",
"_y, nD: ...ЧAiDL_ܷQL....\n",
				}));
				ob->set_temp("try/fon",5);
			}
			break;
		case 10:
			if( strsrch(msg,"")>=0 || strsrch(msg,"n")>=0 ) {
				do_chat(
"_yWx_}}w, ۬hj, ӫݹD: WƻD?\n"
				);
				ob->set_temp("try/fon",13);
			}
			break;
		case 13:
			if( strsrch(msg,"")>=0 ) {
				do_chat(({
"_D: , hjAFoƳ, ̰QF, ť, Han
zoF.\n",
"_D: ڷݷݥs, Wnͺ٥L, @\\ <NP> B, 
MsL, iOLǷPܦn, jaDO.\n",
"_MF_, D: iOT~heݷݤQַt, bѨ~...\n",
"_۹D: HaDF, ..  hj~j, @wOoڷݷݻ.\n",
				}));
				ob->set_temp("try/fon",15);
			}
			break;
		default:	break;
	}
}

void set_fon_temp(object me)
{
	if( me->query_temp("try/fon")!=48 )	return;
	me->set_temp("try/fon",50);
}
