// teacher.c

#include <npc.h>

inherit F_VILLAGER;

string *literate_text = ({
    "H", "ʥ",
    "ʬ۪", "߬ۻ",
    "e", "ʤDE",
    "ФD", "QHM",
    "s", "ܾFB",
    "l", "_V",
    "uPs", "q",
    "Фl", "WѴ",
    "i", "L",
    "ФY", "vk",
    "Hl", "֮",
    "ˮv", "§",
});

int text_cnt = 0;
object picked_student;

void teach_literate();
void pick_student(object ob);
void cancel_pick(object ob);

void create()
{
    set_name("h", ({ "wang whaiz", "wang", "whaiz" }) );
    set_race("human");
    set_level(5);
    set_stat_maximum("sen", 50);

    set_skill("literate", 60);
    set("long",
        "h۬OW~WlMeX~WʦҸոġMIӤҤHL@\n"
        "M]dbamAMvLơMK}FpѱWĤlŪѡC\n");
    set("chat_chance", 8);
    set("chat_msg", ({
        (: teach_literate :)
    }));
    setup();
}

void init()
{
    add_action("do_sit", "sit");
}

int do_sit(string arg)
{
    // add by dragoon
    if( this_player()->query_skill("literate") > 29 ) 
	return notify_fail("AŪѦrڰ򤣿AݭnAťTrgFC\n");
	
    if( this_player()->query_temp("pending/sit_learning_literate") )
        return notify_fail("Awg۱MťFC\n");
    message_vision("$NF@ӪŦ짤FUӡM}lۤѮvѡC\n",
        this_player() );
    this_player()->set_temp("pending/sit_learning_literate", 1);
    return 1;
}

void teach_literate()
{
    object *students, ob;
    string txt;

    if( text_cnt >= sizeof(literate_text) ) {
        command("say  ... @ФӦhA̤]OMnaMڭ̦AqYƲߤ@C\n");
        text_cnt = 0;
    }
    txt = literate_text[text_cnt++];
    command("say jaۧکR" + txt + "C\n");

    students = all_inventory(environment());
    foreach(ob in students)
    {
	if( !ob->query_temp("pending/sit_learning_literate")
	||  !living(ob)
	||  ob->is_fighting()
	||  ob->query_skill("literate",1) >= 30 ) continue;

	ob->improve_skill("literate", random(ob->query_attr("int")+1));
	message_vision("$N۩DR" + txt + "C\n", ob);

	/* Dѥͪ */
	// [random, MC@yN -Dragoon
	if( interactive(ob) && random(10) > 7 
	&&  ob->query_class()=="commoner"
	&&  ob->query_skill("literate") >= 5
	&&  member_array(ob->query_race(), ({
		"human", "woochan", "jiaojao", "rainnar"
	    })) != -1
	&&  ob->query_attr("int") > random(20) )
	    do_chat( (: pick_student, ob :) );
    }
}

int accept_fight()
{
    do_chat("hۻDRo ...Z\\ڥiObI|MoBͤphڭ̮aYRRS\n");
    return 0;
}

string rank(string politeness, int raw)
{
    if( raw ) return ::rank(politeness, raw);
    switch(politeness) {
        case "self": return "p";
        case "respectful": return "Ѯv";
        default:
            return ::rank(politeness, raw);
    }
}

int accept_info(object ob, string type)
{
    return type=="skills";
}

int acquire_skill(object who, string skill)
{
    if( skill=="literate" ) {
	command("say QŪѦrܡSbo̧(sit)ťaC\n");
	command("smile");
	command("say ŪѥieMLǤFh֤@lOAC\n");
	return 1;
    }
    return 0;
}

void pick_student(object ob)
{
    if( ! (ob && present(ob) && interactive(ob)) ) return;

    command("say " + ob->name() + "AAbڳoѦ@qɶFC\n");
    command("say ڬݧAŪѻᦳAѥ]C\n");
    command("say QQMѮv@ˡA@Ӯѥ͡H\n");

    ob->set_temp("pending/picked_by_whaiz", 1);
    call_out( (: cancel_pick, ob :), 20);
}

void cancel_pick(object ob)
{
    if( ! ob ) return;

    ob->delete_temp("pending/picked_by_whaiz");
    if( present(ob) ) {
	command("pat " + ob->query("id"));
	command("say ]}AHUӡC");
    }
}

void make_new_scholar(object ob)
{
    if( !ob || !present(ob) || !interactive(ob)) return;

    ob->set_class("scholar");
    command("smile");
    tell_object(ob, "( A@ѥ )\n");
}

void relay_say(object who, string msg)
{
    if( ! who->query_temp("pending/picked_by_whaiz") ) return;
    if( member_array(msg[0..1], ({"Q", "O", "n"})) != -1 ) {
	do_chat((: make_new_scholar, who :));
	who->delete_temp("pending/picked_by_whaiz");
    }
}
