// bank.c

inherit ROOM;

void init()
{
    add_action("do_convert", "convert");
    add_action("do_deposit", "deposit");
    add_action("do_withdraw", "withdraw");
    add_action("do_new_account", "open");
}

int do_new_account(string arg)
{
    int bal;
    object bankbond;

    if( !arg || arg!="account" ) return 0;
    if( present("bankbond", this_player()) )
        return notify_fail("Awg@ӤYFC\n");
    seteuid(geteuid(this_player()));
    bankbond = new("/obj/bankbond");
    if( !bankbond->move(this_player()) ) {
        write("AWFӦhFMaʿC\n");
        destruct(bankbond);
        return 1;
    }
    bankbond->set("owner_id", geteuid(this_player()));
    bal = this_player()->query("bank_account");
    if( bal>0 ) {
        write("dbïM@OҪMsoA@isC\n");
        bankbond->set_balance(bal*9/10);
    } else if( bal==0 ) {
        write("AM@PeFӪM@HӪ̾ڡC\n");
        write("A@iMWOۧA{bYپlUhֿC\n");
        bankbond->set_balance(0);
    } else {
        write("AbïXFID, ЧŮvC\n");
        destruct(bankbond);
    }
    return 1;
}

int do_convert(string arg)
{
    string from, to;
    int amount, bv1, bv2;
    object from_ob, to_ob;

    if( !arg || sscanf(arg, "%d %s to %s", amount, from, to)!=3 )
        return notify_fail("O榡Rconvert <ƶq> <f> to <f>\n");

    seteuid(getuid());
    from_ob = present(from + "_money", this_player());
    to_ob = present(to + "_money", this_player());
    if( !to_ob && file_size("/obj/money/" + to + ".c") < 0 )
        return notify_fail("AQI@ؿS\n");

    if( !from_ob )        return notify_fail("AWSoسfC\n");
    if( amount < 1 )    return notify_fail("If@ܤ֭nI@ӡC\n");
        
    if( (int)from_ob->query_amount() < amount )
        return notify_fail("AWSh" + from_ob->name() + "C\n");

    bv1 = from_ob->query("base_value");
    if( !bv1 ) return notify_fail("oتF褣ȿC\n");

    bv2 = to_ob ? to_ob->query("base_value") : call_other("/obj/money/" + to, "query", "base_value" );
    if( !bv2 ) return notify_fail("AnI@سfS\n");

    if( bv1 < bv2 ) amount -= amount % (bv2 / bv1);
    if( amount==0 )    return notify_fail("o" + from_ob->name() + "ȤӧCFM_C\n");

    if( !to_ob ) {
        to_ob = new("/obj/money/" + to);
        to_ob->move(this_player());
        to_ob->set_amount(amount * bv1 / bv2);
    } else
        to_ob->add_amount(amount * bv1 / bv2);

    message_vision( sprintf("$NqWX%s%s%sM%s%s%sC\n",
        chinese_number(amount), from_ob->query("base_unit"), from_ob->name(),
        chinese_number(amount * bv1 / bv2), to_ob->query("base_unit"), to_ob->name()),
        this_player() );

    from_ob->add_amount(-amount);

    return 1;
}

int do_deposit(string arg)
{
    int amount;
    string money;
    object money_ob, bond;

    seteuid(getuid());
    if( !bond = present("bankbond", this_player()) )
        return notify_fail("ЧA}@ӤYC\n");

    if( geteuid(this_player()) != bond->query("owner_id") ) {
        write("o{A㤣MSFAC\n");
        destruct(bond);
        return 1;
    }

    if( bond->query_balance() != this_player()->query("bank_account") ) {
        write("o{WbؤMSFAC\n");
        destruct(bond);
        return 1;
    }

    if( !arg || sscanf(arg, "%d %s", amount, money)!=2 )
        return notify_fail("O榡Rdeposit <ƶq> <f>C\n");

    if( amount < 0 )
        return notify_fail("AsJsHUC\n");
        
    if( !money_ob = present(money + "_money", this_player()) )
        return notify_fail("AWSoؿC\n");

    if( money_ob->query_amount() < amount )
        return notify_fail("AWSoh" + money_ob->name() + "C\n");

    bond->transact(amount * money_ob->query("base_value"));
    money_ob->add_amount( - amount );
    write("AN" + chinese_number(amount) + money_ob->query("base_unit")
        + money_ob->name() + "εMsoA@isC\n");
    this_player()->save_autoload();
        this_player()->save();
    return 1;
}

int do_withdraw(string arg)
{
    int amount;
    string money;
    object money_ob, bond;

    seteuid(getuid());
    if( !bond = present("bankbond", this_player()) )
        return notify_fail("ЧA}@ӤYC\n");

    if( geteuid(this_player()) != bond->query("owner_id") ) {
        write("o{A㤣MSFAC\n");
        destruct(bond);
        return 1;
    }

    if( bond->query_balance() != this_player()->query("bank_account") ) {
        write("o{WbؤMSFAC\n");
        destruct(bond);
        return 1;
    }

    if( !arg || sscanf(arg, "%d %s", amount, money)!=2 )
        return notify_fail("O榡Rwithdraw <ƶq> <f>C\n");

    if( amount < 0 )
        return notify_fail("AണsHUfC\n");

    if( amount > 30000) 
        return notify_fail("A@ӦhC\n");    

    if( file_size("obj/money/" + money + ".c") < 0 )
	return notify_fail("An@ؿS\n");

    if( catch(money_ob = new("/obj/money/" + money)) ) return 0;

    money_ob->set_amount(amount);
    if( bond->query_balance() < money_ob->value() ) {
        destruct(money_ob);
        return notify_fail("AY̨SohC\n");
    }

    bond->transact(- money_ob->value());
    if( !money_ob->move(this_player()) ) {
        bond->transact(money_ob->value());
        destruct(money_ob);
        return notify_fail("AWaFo\\hM֤@IaC\n");
    }

    write("N" + chinese_number(amount) + money_ob->query("base_unit")
        + money_ob->name() + "εAMísoA@isC\n");
        this_player()->save_autoload();
        this_player()->save();
    return 1;
}
